%define	__s		-s
%define	__soversion	3.1
%define	_libdb_a	libdb-%{__soversion}.a
%{!?_lib: %define _lib	lib}

Summary: BSD database library for C
Name: db3
Version: 3.1.14
Release: 0.3.6x
Source: http://www.sleepycat.com/update/%{version}/db-%{version}.tar.gz
Patch0: http://www.sleepycat.com/update/%{version}/patch.3.0.55.1
Patch1: db-3.0.55-linux.patch
Patch2: db-3.0.55-jbj.patch
URL: http://www.sleepycat.com
Copyright: GPL
Group: System Environment/Libraries
PreReq: /sbin/ldconfig

# XXX written as a file prereq in order to build with glibc-2.1.3
%ifos linux
BuildPrereq: /usr/lib/libdb1.a
# XXX Red Hat 7.0 packages db3 differently
Conflicts: glibc > 2.1.3
%endif

BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{_prefix}

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB is used by many applications, including Python and Perl, so this
should be installed on all systems.

%package utils
Summary: Command line tools for managing Berkeley DB databases.
Group: Applications/Databases
Prefix: %{_prefix}

%description utils
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains command line tools for managing Berkeley DB databases.

%package devel
Summary: Development libraries and header files for Berkeley database library
Group: System Environment/Libraries
Prefix: %{_prefix}

%description devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains the header files, libraries, and documentation for
building programs which use Berkeley DB.

%prep
%setup -q -n db-%{version}
#%patch0 -p0
#%patch1 -p1 -b .linux

# XXX not applied
#%patch1 -p1 -b .jbj

%build

cd build_unix

# XXX --enable-posixmutexes (missing pthread_{cond,mutex}attr_setpshared)
# XXX --enable-cxx (barfs on clone proto in /usr/include/bits/sched.h)
# XXX --enable-debug_{r,w}op should be disabled for production.
CFLAGS="$RPM_OPT_FLAGS" ../dist/configure --prefix=%{_prefix} --enable-debug --enable-compat185 --enable-diagnostic --enable-dump185 --enable-shared --enable-static --enable-rpc --enable-tcl # --enable-test --enable-debug --enable-debug_rop --enable-debug_wop # --enable-posixmutexes

make libdb=%{_libdb_a} %{_libdb_a}

# Static link with old db-185 libraries.
/bin/sh ./libtool --mode=compile cc -c -O2 -g -g -I/usr/include/db1 -I../dist/../include -D_REENTRANT  ../dist/../db_dump185/db_dump185.c
cc %{__s} -static -o db_dump185 db_dump185.lo -L%{_libdir} -ldb1

# Compile rest normally.
make libdb=%{_libdb_a} TCFLAGS='-I$(builddir) -I/usr/include' LDFLAGS="%{__s}"

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_includedir}
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/lib

cd build_unix

# XXX install_static_cxx
# XXX install_dynamic_cxx
# XXX install_java
# XXX install_docs (handled by %docs)
make libdb=%{_libdb_a} LDFLAGS="%{__s}" prefix=${RPM_BUILD_ROOT}%{_prefix} install_include install_dynamic install_static install_tcl install_utilities

# XXX annoying
set -x
( cd ${RPM_BUILD_ROOT}

%ifos linux
  mkdir -p ./%{_lib}
  mv .%{_prefix}/lib/libdb[-.]*so* ./%{_lib}
  if [ "%{_libdir}" != "%{_prefix}/lib" ]; then
    mkdir -p .%{_libdir}
    mv .%{_prefix}/lib/libdb* .%{_libdir}
  fi
%endif

  mkdir -p .%{_includedir}/db3
  mv .%{_prefix}/include/*.h .%{_includedir}/db3

# XXX avoid name collisions
#  ln -sf db3/db.h .%{_includedir}/db.h
  for F in .%{_prefix}/bin/db_* ; do
    mv $F `echo $F | sed -e 's,/db_,/db3_,'`
  done
)
set +x

%clean
rm -rf ${RPM_BUILD_ROOT}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc LICENSE README docs/images
%ifos linux
/%{_lib}/libdb-%{__soversion}.so
%else
%{_libdir}/libdb-%{__soversion}.so
%endif

%files utils
%defattr(-,root,root)
%doc	docs/utility
%{_libdir}/libdb_tcl-%{__soversion}.so
%{_bindir}/berkeley_db_svc
%{_bindir}/db*_archive
%{_bindir}/db*_checkpoint
%{_bindir}/db*_deadlock
%{_bindir}/db*_dump
%{_bindir}/db*_dump185
%{_bindir}/db*_load
%{_bindir}/db*_printlog
%{_bindir}/db*_recover
%{_bindir}/db*_stat
%{_bindir}/db*_upgrade
%{_bindir}/db*_verify

%files devel
%defattr(-,root,root)
%doc	docs/api_c docs/api_cxx docs/api_java docs/api_tcl docs/index.html
%doc	docs/ref docs/sleepycat
%doc	examples_c examples_cxx
%{_libdir}/libdb-%{__soversion}.la
%{_libdir}/libdb_tcl-%{__soversion}.la
%{_libdir}/%{_libdb_a}
%{_includedir}/db3/db.h
%{_includedir}/db3/db_185.h
%{_includedir}/db3/db_cxx.h
#%{_includedir}/db.h
%ifos linux
/%{_lib}/libdb.so
%else
%{_libdir}/libdb.so
%endif
%{_libdir}/libdb_tcl.so

%changelog
* Fri Jul 21 2000 Jeff Johnson <jbj@redhat.com>
- make sure that %%_lib is set.

* Sun Jun 11 2000 Jeff Johnson <jbj@redhat.com>
- upgrade to 3.1.14.
- create db3-utils sub-package to hide tcl dependency, enable tcl Yet Again.
- FHS packaging.

* Mon Jun  5 2000 Jeff Johnson <jbj@redhat.com>
- disable tcl Yet Again, base packages cannot depend on libtcl.so.

* Sat Jun  3 2000 Jeff Johnson <jbj@redhat.com>
- enable tcl, rebuild against tcltk 8.3.1 (w/o pthreads).

* Tue May 30 2000 Matt Wilson <msw@redhat.com>
- include /lib/libdb.so in the devel package

* Wed May 10 2000 Jeff Johnson <jbj@redhat.com>
- put in "System Environment/Libraries" per msw instructions.

* Tue May  9 2000 Jeff Johnson <jbj@redhat.com>
- install shared library in /lib, not /usr/lib.
- move API docs to db3-devel.

* Mon May  8 2000 Jeff Johnson <jbj@redhat.com>
- don't rename db_* to db3_*.

* Tue May  2 2000 Jeff Johnson <jbj@redhat.com>
- disable --enable-test --enable-debug_rop --enable-debug_wop.
- disable --enable-posixmutexes --enable-tcl as well, to avoid glibc-2.1.3
  problems.

* Mon Apr 24 2000 Jeff Johnson <jbj@redhat.com>
- add 3.0.55.1 alignment patch.
- add --enable-posixmutexes (linux threads has not pthread_*attr_setpshared).
- add --enable-tcl (needed -lpthreads).

* Sat Apr  1 2000 Jeff Johnson <jbj@redhat.com>
- add --enable-debug_{r,w}op for now.
- add variable to set shm perms.

* Sat Mar 25 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.0.55

* Tue Dec 29 1998 Jeff Johnson <jbj@redhat.com>
- Add --enable-cxx to configure.

* Thu Jun 18 1998 Jeff Johnson <jbj@redhat.com>
- Create.
